// Simple Arduino sketch for a stand-alone traffic light by M. Stal, (c) 2013

int red 		= 8;          	// red LED
int yellow 		= 9;       	// yellow LED
int green 		= 10;       	// green LED
int loudspeaker 	= 11; 		// Loudspeaker

int REDPHASE 		= 	5000;	// Duration Red
int BEFOREGREEN 	= 	2000; 	// Duration Before Green
int GREENPHASE 	= 	10000; 	// Duration Green
int BEFORERED  	= 	2000;  	// Duration Before Red
int TONE_DELAY 	= 	50;    	// Delay between tones
int IR 			= 	0;    	// Interrupthandler IR called on CHANGE


// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pins as output.
  pinMode(red, OUTPUT);   
  pinMode(yellow, OUTPUT);
  pinMode(green, OUTPUT);  
  pinMode(loudspeaker, OUTPUT);
  Serial.begin(9600);
}

void redHigh() {
  digitalWrite(red, HIGH);
  Serial.println("Red on");
}
void redLow() {
  digitalWrite(red, LOW);
  Serial.println("Red off");
}

void yellowHigh() {
  digitalWrite(yellow, HIGH);
  Serial.println("Yellow On");
}
void yellowLow() {
  digitalWrite(yellow, LOW);
  Serial.println("Yellow off");
}

void greenHigh() {
  digitalWrite(green, HIGH);
  Serial.println("Green on");
}
void greenLow() {
  digitalWrite(green, LOW);
  Serial.println("Green off");
}

void redPhase() { 
  Serial.println("Red Phase");
  redHigh(); 
  toneSignalRed();
  yellowLow();
  greenLow();
  delay(REDPHASE);
  beforeGreen();
}

void beforeGreen() {
  Serial.println("Before Green Phase");
  redHigh();
  yellowHigh();
  greenLow();
  delay(BEFOREGREEN);
  greenPhase();
}

void greenPhase() {
  Serial.println("Green Phase");
  redLow();
  yellowLow();
  greenHigh();
  toneSignalGreen();
  delay(GREENPHASE);
  beforeRed();
}

void beforeRed() {
  Serial.println("Before Red Phase");
  redLow();
  yellowHigh();
  greenLow();
  delay(BEFORERED);
  redPhase();
}


void toneSignalRed() {
  for (int i = 0; i < 10; i++) {
      tone(loudspeaker, 440);
      delay(100);
      tone(loudspeaker, 360);
      delay(100);
  }
  noTone(loudspeaker);
}

void toneSignalGreen() {
  for (int i = 0; i < 10; i++) {
      tone(loudspeaker, 240);
      delay(100);
      tone(loudspeaker, 160);
      delay(100);
  }
  noTone(loudspeaker);
}


void emergencyHandler() {
  for (int i = 0; i < 10; i++) {
      tone(loudspeaker, 240);
      delay(TONE_DELAY);
      tone(loudspeaker, 160);
      delay(TONE_DELAY);
      tone(loudspeaker, 440);
      delay(TONE_DELAY);
  }
    
}
// the loop routine runs over and over again forever:
void loop() {
 noTone(loudspeaker);
 attachInterrupt(IR, emergencyHandler, CHANGE);
 redPhase();
}

